Bug 560102 - arg validation hole with stores vs no-data-dir
Summary: arg validation hole with stores vs no-data-dir
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp
Version: Development
Hardware: All
OS: Linux
low
medium
Target Milestone: 1.3
: ---
Assignee: Kim van der Riet
QA Contact: MRG Quality Engineering
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-01-29 20:47 UTC by jrd
Modified: 2013-02-27 04:26 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-07-05 14:38:18 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description jrd 2010-01-29 20:47:22 UTC
Description of problem:

When using a persistent store in cluster mode, if you say --no-data-dir, the wrong thing happens at init time, and the broker comes up in a confused state


Version-Release number of selected component (if applicable):

trunk

How reproducible:

always

Steps to Reproduce:
1.  start two brokers with a stores, specify --store-dir, and --no-data-dir
2.  create some objects
3.  bounce and restart a broker
  
Actual results:

broker recovers objects from the store, when it shouldn't,

Expected results:

should get statea from the peer.

Additional info:

Comment 1 Kim van der Riet 2010-02-02 16:00:52 UTC
This is a logic flaw in the cluster store status. When --no-data-dir is specified, the logic which discards the store for the second and subsequent nodes fails to run. In addition, the cluster has nowhere to write its store status information which is normally written into the data directory.

Considering that the store-dir used by the async store is unique to that store and is not available on stores generally, it makes sense therefore to make the use of --data-dir mandatory when the cluster is loaded together with any non-null store. This fix now will stop the broker with an error message if --no-data-dir is used in the presence of any non-null store.

Fixed in r.905680

QA: This bug is easy to reproduce using the above steps. After the fix, the above should prevent the broker from starting with an error message.

Comment 2 Kim van der Riet 2010-09-10 13:41:25 UTC
This was checked onto the branch prior to the mrg 1.3.x rebase

Comment 3 Kim van der Riet 2010-09-10 13:42:08 UTC
(In reply to comment #2)
> This was checked onto the branch prior to the mrg 1.3.x rebase

Should be: This was checked onto the trunk prior to the mrg 1.3.x rebase.


Note You need to log in before you can comment on or make changes to this bug.